#include "doorkeeper/helpers/hashing.hpp"
#include "tiger.h"

namespace dk {
	namespace {
		enum {
			TigerPaddingV2 = 0x80,
			TigerPaddingV1 = 0x01
		};
	} //unnamed namespace

	namespace implem {
		HashType hash_string (const char* parString, std::size_t parLen) {
			union {
				HashType hash;
				t_res array;
			} retval;

			tiger(parString, parLen, retval.array, TigerPaddingV2);
			return retval.hash;
		}

		bool HashType::operator< (const HashType& parOther) const {
			return a < parOther.a or
				(a == parOther.a and b < parOther.b) or
				(a == parOther.a and b == parOther.b and c < parOther.c)
			;
		}
	} //namespace implem
} //namespace dk
